/*
/**************************************************************
TITLE		GLWbN No6@^C}IC555ȂI
SUBTITLE	Misson4 dqIKPIC12F675œ̂Q d敪œǂݎ
AUTHER		Program Copyrights(C)2008  air variable
			http://www.ne.jp/asahi/air/variable/
			
Project folder 		C:\picsrc\ej_organ2

Version of histrory
Date	:Time	Version	Build	Author	Note
20080511:0551	0.10	---		air_variable	begin the program	
**************************************************************/
/*
Hard ware Pin assignment list
1	VDD					8	VSS
2	GP5	I(not used)		7	GP0	AN0 analog sens
3	GP4	I(not used)		6	GP1	O sound out
4	GP3	I (not used)	5	GP2	I (not used)

VDD 4.5 to 5V
*/


#include <pic.h>
#include "delay.h"

#define XTAL_FREQ 4MHZ		//IV[^x
#define BUZZ_OUT	GPIO1 //̏o̓|[gݒ(6pin)
#define LOOPTRIM	40	//ԃWݒ(K)

//K`
#define	Tone_C   	139
#define	Tone_Cs  	145
#define	Tone_D   	152
#define	Tone_Ds  	158
#define	Tone_E   	163
#define	Tone_F   	169
#define	Tone_Fs  	174
#define	Tone_G   	178
#define	Tone_Gs  	183
#define	Tone_A   	187
#define	Tone_As  	191
#define	Tone_B   	195
#define	Tone_CH  	198

__CONFIG(0x3FC4);
unsigned char tone;	//̔ԍɓ

void interrupt toneset( void )
{	//荞݂̓^C}[0݂̂gpĂ̂ŁA荞݂̗vׂ͒Ȃ
    TMR0 = tone;//TMR0̒lXV
	if (tone >=240 ) tone =240 ; //value limitation
	if (tone != 0){		//tone[łȂΉo
		if (BUZZ_OUT)	//BUZZ_OUT1Ȃ
			BUZZ_OUT=0;	//0ɐ؂ւ
		else			//0Ȃ
			BUZZ_OUT=1;	//1ɐ؂ւ
	}
	T0IF =0;	//^C}[0tONA
}	//荞݂𔲂


void adinit()
{
//ADϊ̃NbNI(ANSEL) Fosc/8I
	ADCS2=0;
	ADCS1=0;
	ADCS0=1;
//AiO|[g̑I(ANSEL)
	ANS3=0;//fW^I
	ANS2=0;//fW^I
	ANS1=0;//fW^I
	ANS0=1;//AiOI
//ADRo[^[hݒ(ADCON0)
	ADON=1;	//ADRo[^dI
	ADFM=1;	//E
	VCFG=0;	//Vref͓ddɐݒ
}
unsigned int adconv(char adselect)
{
	unsigned int temp;
	ADCON0 = (ADCON0 & 0b11110011) |(( adselect <<2) & 0b00001100);//AD`lZbg 
	DelayUs(20);//20us waitiANCWVϊԂKvj
	GODONE=1;	//ϊX^[g
	while(GODONE);//ADϊ(46usec)
	temp =ADRESH;
	temp =( temp<<8 )| ADRESL;//10rbgɍadconv̋Alɓn
	return temp;
}

wtime(unsigned int t0)
{	//\tgEFAł̑҂Ԑ[`
    unsigned int i,t1;
    for ( i=0 ; i != t0 ;i++)
    {
        t1 = LOOPTRIM;
        while ( --t1 );
    }
}

//------------------main
main()
{
//Initialization
//Power Hold 1:Power is hold 0:Power is off
	unsigned int ad_data;
	OSCCAL = _READ_OSCCAL_DATA();//OSCCAL AUTO SET
	GIE		= 0;			//荞݂͋֎~ɂĂ 
	OPTION 	= 0b10000010; //^C}[0̃vXP[ 1/8 |[gvAbvL((7)GPPU=1)
    CMCON	= 7;
			//  76543210
    TRISIO 	= 0b11111101;	//GP1(6pin)o 
    GPIO	= 0b00000000;	//GPIO|[g̏
	WPU		= 0b00000000;	//vAbvgp
    TMR0	= 0x00 ;		//^C}[0

	adinit();		//ADRo[^̏


	PEIE	= 1;	//ytF荞ݗL
	T0IE	= 1;	//^C}[0荞ݗL
	GIE		= 1;	//S荞ݏL 

	while(1){
		ad_data = adconv(0);//ADl擾 ADl10rbg0`1023iK
		if (ad_data <=80 )	tone = 0;	//炳Ȃ
		if ((ad_data >  80)&&(ad_data <=  93))	tone =	Tone_C;
		if ((ad_data >  93)&&(ad_data <= 104))	tone =	Tone_C;
		if ((ad_data > 104)&&(ad_data <= 113))	tone =	Tone_D;
		if ((ad_data > 113)&&(ad_data <= 124))	tone =	Tone_D;
		if ((ad_data > 124)&&(ad_data <= 135))	tone =	Tone_E;
		if ((ad_data > 135)&&(ad_data <= 151))	tone =	Tone_E;
		if ((ad_data > 151)&&(ad_data <= 166))	tone =	Tone_F;
		if ((ad_data > 166)&&(ad_data <= 185))	tone =	Tone_F;
		if ((ad_data > 185)&&(ad_data <= 236))	tone =	Tone_G;
		if ((ad_data > 236)&&(ad_data <= 287))	tone =	Tone_G;
		if ((ad_data > 287)&&(ad_data <= 385))	tone =	Tone_A;
		if ((ad_data > 385)&&(ad_data <= 445))	tone =	Tone_A;
		if ((ad_data > 445)&&(ad_data <= 512))	tone =	Tone_B;
		if ((ad_data > 513)&&(ad_data <= 594))	tone =	Tone_B;
		if ((ad_data > 594)&&(ad_data <= 737))	tone =	Tone_CH;
		if (ad_data > 737)	tone =	Tone_CH;
				
//		if (ad_data 
//		else tone = (unsigned char)((ad_data - 140)/2) +19 ;//炵n̓hiCj炷
	}
}
